function [PCs, SPCs, EigVec_PCA, EigVec_SPCA] = PC_SPC(X, Std_term)
        %./ X has to be a T by N matrix where T is the number of
        %./ observations for each variable while N is the number of variables
        [rows, cols] = size(X);
        
        Z = sqrt(rows)*X./repmat(Std_term, [rows 1]);    
        
        [~, S, V] = svd(Z);
        SumS = sum(diag(S));
        Stilde = diag(S)/SumS;
        CumSum = [];
        for i = 1:length(Stilde)
           CumS = sum(Stilde(1:i));
           CumSum = [CumSum; CumS];  
        end
        Num = length(find(CumSum<=0.90));
        if Num == 0
            Num = 1;
        end
        Num1 = length(find(Stilde>=0.05));
        if Num1 == 0 
            Num1 = 1;
        end
        Num = min(Num, Num1);
        PCs = X*V(:, 1:Num);
        EigVec_PCA = V(:, 1:Num);
        
      if floor(cols/rows) >= 1.25
       [spca_coeff, SD] = spca(Z, [], 15, inf, -round(linspace(0.8*size(X,2),0.6*size(X,2),15)), 3000, 1e-6); 
      else
       [spca_coeff, SD] = spca(Z, [], 15, 0.5, -round(linspace(0.8*size(X,2),0.6*size(X,2),15)), 3000, 1e-6);
      end
        Sorted_SD = sort(SD, 'descend');
        Spot = [];
        for dd = 1:length(Sorted_SD)
            spot = find(SD == Sorted_SD(dd));
            Spot = [Spot;spot];
        end
        Sorted_spca_coeff = [];
        for ddd = 1:length(Sorted_SD)
          Sorted_spca_coeff = [Sorted_spca_coeff, spca_coeff(:,Spot(ddd))];    
        end   
        SumSD = sum(Sorted_SD);
        Ratio_SD = Sorted_SD/SumSD;
        CumSumSD = [];
        for i = 1:length(Ratio_SD)
           CumS = sum(Ratio_SD(1:i));
           CumSumSD = [CumSumSD; CumS];  
        end        
        NumSD = length(find(CumSumSD<=0.90));
        if NumSD == 0
            NumSD = 1;
        end        
        NumSD1 = length(find(Ratio_SD>=0.05));
        if NumSD1 == 0
            NumSD1 = 1;
        end
        NumSD = min(NumSD, NumSD1);
        SPCs = X*Sorted_spca_coeff(:, 1:NumSD);
        EigVec_SPCA = Sorted_spca_coeff(:, 1:NumSD);

end