clear;clc;

load FactorDetails_Rotate_SPY_10min.mat
load Dataset_Pool_10min.mat
load TotalStocks.mat
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%     Main Programme    %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%./ Parametrization and Data Loading ./%
Freq = 1/39;                   %./ Sampling Frequency: 1-min 
Pool = [Dataset_Pool_10min(:, 1:215),...  %./ Loading other individual stocks (Num: 274)
    Dataset_Pool_10min(:, 217:263), Dataset_Pool_10min(:,273:277)];
[rows, cols] = size(Pool);
Range = [879, 1258];

Factor_Pool = Pool((Range(1)-1)/Freq+1:Range(2)/Freq,:);

Name = Stock_Sectors(:,1);
Sector = Stock_Sectors(:,2);

Output_PCA_EN1 = {};
Output_SPCA_EN1 = {};
Output_PCA_EN2 = {};
Output_SPCA_EN2 = {};
Output_PCA_Lasso = {};
Output_SPCA_Lasso = {};

for j = 1:cols
  Output_PCA_EN1{j,1} = Name(j);
  Output_PCA_EN1{j,2} = Sector(j);
  
  Output_SPCA_EN1{j,1} = Name(j);
  Output_SPCA_EN1{j,2} = Sector(j);
  
  Output_PCA_EN2{j,1} = Name(j);
  Output_PCA_EN2{j,2} = Sector(j);
  
  Output_SPCA_EN2{j,1} = Name(j);
  Output_SPCA_EN2{j,2} = Sector(j);  
  
  Output_PCA_Lasso{j,1} = Name(j);
  Output_PCA_Lasso{j,2} = Sector(j);
  
  Output_SPCA_Lasso{j,1} = Name(j);
  Output_SPCA_Lasso{j,2} = Sector(j);
  
end

for i = 1:380
    
    Day_Pool = Factor_Pool((i-1)/Freq+1: i/Freq,:);
    
    Day_Weight_PCA_EN1 = cell2mat(EigVec_Mat_PCA_EN1_Rotate(:,i+2));
    
    Day_Weight_SPCA_EN1 = cell2mat(EigVec_Mat_SPCA_EN1_Rotate(:,i+2));
    
    Day_Weight_PCA_EN2 = cell2mat(EigVec_Mat_PCA_EN2_Rotate(:,i+2));
    
    Day_Weight_SPCA_EN2 = cell2mat(EigVec_Mat_SPCA_EN2_Rotate(:,i+2));
    
    Day_Weight_PCA_Lasso = cell2mat(EigVec_Mat_PCA_Lasso_Rotate(:,i+2));
    
    Day_Weight_SPCA_Lasso = cell2mat(EigVec_Mat_SPCA_Lasso_Rotate(:,i+2));
    
    Factor_Vol_PCA_EN1 = sum((Day_Pool*Day_Weight_PCA_EN1).^2);
    
    Ind_Vol_PCA_EN1 = sum(((Day_Pool).*(repmat(Day_Weight_PCA_EN1, [1,1/Freq])')).^2);
    
    Relat_Contrib_PCA_EN1 = 100*(Ind_Vol_PCA_EN1./(Factor_Vol_PCA_EN1*ones(1,cols)));
    
    Factor_Vol_SPCA_EN1 = sum((Day_Pool*Day_Weight_SPCA_EN1).^2);
    
    Ind_Vol_SPCA_EN1 = sum(((Day_Pool).*(repmat(Day_Weight_SPCA_EN1, [1,1/Freq])')).^2);
    
    Relat_Contrib_SPCA_EN1 = 100*(Ind_Vol_SPCA_EN1./(Factor_Vol_SPCA_EN1*ones(1,cols)));
    
    Factor_Vol_PCA_EN2 = sum((Day_Pool*Day_Weight_PCA_EN2).^2);
    
    Ind_Vol_PCA_EN2 = sum(((Day_Pool).*(repmat(Day_Weight_PCA_EN2, [1,1/Freq])')).^2);
    
    Relat_Contrib_PCA_EN2 = 100*(Ind_Vol_PCA_EN2./(Factor_Vol_PCA_EN2*ones(1,cols)));
    
    Factor_Vol_SPCA_EN2 = sum((Day_Pool*Day_Weight_SPCA_EN2).^2);
    
    Ind_Vol_SPCA_EN2 = sum(((Day_Pool).*(repmat(Day_Weight_SPCA_EN2, [1,1/Freq])')).^2);
    
    Relat_Contrib_SPCA_EN2 = 100*(Ind_Vol_SPCA_EN2./(Factor_Vol_SPCA_EN2*ones(1,cols)));
    
    Factor_Vol_PCA_Lasso = sum((Day_Pool*Day_Weight_PCA_Lasso).^2);
    
    Ind_Vol_PCA_Lasso = sum(((Day_Pool).*(repmat(Day_Weight_PCA_Lasso, [1,1/Freq])')).^2);
    
    Relat_Contrib_PCA_Lasso = 100*(Ind_Vol_PCA_Lasso./(Factor_Vol_PCA_Lasso*ones(1,cols)));
    
    Factor_Vol_SPCA_Lasso = sum((Day_Pool*Day_Weight_SPCA_Lasso).^2);
    
    Ind_Vol_SPCA_Lasso = sum(((Day_Pool).*(repmat(Day_Weight_SPCA_Lasso, [1,1/Freq])')).^2);
    
    Relat_Contrib_SPCA_Lasso = 100*(Ind_Vol_SPCA_Lasso./(Factor_Vol_SPCA_Lasso*ones(1,cols)));    
    
    for k = 1:cols
        
        Output_PCA_EN1{k,i+2} = Relat_Contrib_PCA_EN1(k);
        Output_SPCA_EN1{k,i+2} = Relat_Contrib_SPCA_EN1(k);
        Output_PCA_EN2{k,i+2} = Relat_Contrib_PCA_EN2(k);
        Output_SPCA_EN2{k,i+2} = Relat_Contrib_SPCA_EN2(k);        
        Output_PCA_Lasso{k,i+2} = Relat_Contrib_PCA_Lasso(k);
        Output_SPCA_Lasso{k,i+2} = Relat_Contrib_SPCA_Lasso(k);   
        
    end
    
    
end

Output_PCA_EN1_Average = {};
Output_SPCA_EN1_Average = {};
Output_PCA_EN2_Average = {};
Output_SPCA_EN2_Average = {};
Output_PCA_Lasso_Average = {};
Output_SPCA_Lasso_Average = {};

for j = 1:cols
  Output_PCA_EN1_Average{j,1} = Name(j);
  Output_PCA_EN1_Average{j,2} = Sector(j);
  
  Output_SPCA_EN1_Average{j,1} = Name(j);
  Output_SPCA_EN1_Average{j,2} = Sector(j);
  
  Output_PCA_EN2_Average{j,1} = Name(j);
  Output_PCA_EN2_Average{j,2} = Sector(j);
  
  Output_SPCA_EN2_Average{j,1} = Name(j);
  Output_SPCA_EN2_Average{j,2} = Sector(j);  
  
  Output_PCA_Lasso_Average{j,1} = Name(j);
  Output_PCA_Lasso_Average{j,2} = Sector(j);
  
  Output_SPCA_Lasso_Average{j,1} = Name(j);
  Output_SPCA_Lasso_Average{j,2} = Sector(j);
  
end

for d = 1:cols
    
    Output_PCA_EN1_Average{d,3} = mean(cell2mat(Output_PCA_EN1(d,3:size(Output_PCA_EN1,2))));
    Output_SPCA_EN1_Average{d,3} = mean(cell2mat(Output_SPCA_EN1(d,3:size(Output_SPCA_EN1,2))));
    Output_PCA_EN2_Average{d,3} = mean(cell2mat(Output_PCA_EN2(d,3:size(Output_PCA_EN2,2))));
    Output_SPCA_EN2_Average{d,3} = mean(cell2mat(Output_SPCA_EN2(d,3:size(Output_SPCA_EN2,2)))); 
    Output_PCA_Lasso_Average{d,3} = mean(cell2mat(Output_PCA_Lasso(d,3:size(Output_PCA_Lasso,2))));
    Output_SPCA_Lasso_Average{d,3} = mean(cell2mat(Output_SPCA_Lasso(d,3:size(Output_SPCA_Lasso,2))));    
    
end